Description

This story is to use the syntax from python requirements[0] files to specify which packages should be synced. This story does NOT
include directly uploading a requirements.txt (though that feature could be discussed in another issue)

Note:
It doesn't make sense for Pulp to support all of the possible syntaxes in a requirements file (like specifying a local file).

Background:

At the time of writing, pulp-python only supports a whitelist of project names, but this whitelist should become more granular and
flexible.

Specifiers [1][2]
It would be ideal to support multiple levels of filtering:
® project name
* version specifiers (including gt, It, range)
* specific python distributions (specified by hash) [3]

Allowing users to specify python distributions by hashes [3] will significantly improve 2 of our use cases:

* reproducible, deterministic builds
* improved security

Related Ideas:
These ideas are related to the implementation of this story, but if they are accepted, they should be filed separately.

1. Create a whitelist from a requirements.txt

2. Create a whitelist from a Pipfile (pipenv)

3. Create a whitelist from a Pipfile.lock (pipenv)
4. Create a whitelist from a python toml file

[0]: https://pip.pypa.io/en/stable/user_guide/#requirements-files

[1]: https://www.python.org/dev/peps/pep-0440/

[2]: https://www.python.org/dev/peps/pep-0508/

[3]: https://pip-python3.readthedocs.io/en/latest/reference/pip_install.html#hash-checking-mode

Related issues:
Related to Python Support - Story #2040: As a user, | can choose which packag... CLOSED - DUPLICATE
History

#1 - 06/29/2016 04:48 PM - amacdona@redhat.com

- Related to Story #138: As a user, | can express how many old versions of a package to keep during sync added

#2 - 06/29/2016 04:49 PM - amacdona@redhat.com

requirements.txt format is also the output of “pip freeze, so it would be very simple to convert an environment into a repository.

#3 - 06/29/2016 04:53 PM - amacdona@redhat.com

- Subject changed from As a user, | can pass package names as requirements.txt to As a user, | can pass project names as requirements.txt

#4 - 06/29/2016 04:59 PM - semyers

- Groomed changed from No to Yes

Whoa this is a cool idea. | love it.

Does pip make it easy to get at the requirements.txt parser so we don't have to write one? :)

#5 - 06/29/2016 08:16 PM - amacdona@redhat.com
- Sprint Candidate changed from No to Yes

#6 - 08/25/2016 10:51 PM - bizhang
- Status changed from NEW to POST

- Assignee set to bizhang

#7 - 08/26/2016 02:52 PM - pcreech
- Status changed from POST to NEW
- Assignee deleted (bizhang)

#8 - 09/01/2016 02:40 PM - amacdona@redhat.com
- Sprint Candidate changed from Yes to No

#9 - 05/14/2018 11:52 PM - bizhang
- Tags Pulp 3 added

#10 - 05/15/2018 04:55 AM - amacdona@redhat.com

- Subject changed from As a user, | can pass project names as requirements.txt to As a user, | can whitelist packages to sync with standard python
syntax

- Description updated

#11 - 05/15/2018 05:25 AM - amacdona@redhat.com
- Related to Story #2040: As a user, | can choose which package types to sync added

#12 - 05/15/2018 05:34 AM - bizhang

- Related to deleted (Story #138: As a user, | can express how many old versions of a package to keep during sync)

#13 - 05/19/2018 03:27 AM - bizhang
- Status changed from NEW to POST

- Assignee set to bizhang

PR: https://github.com/pulp/pulp_python/pull/173

#14 - 06/01/2018 08:14 PM - werwty
- Status changed from POST to MODIFIED
- % Done changed from 0 to 100
Applied in changeset fecf6314947b57a8fcfd2692b52b92ac720e659a.

#15 - 04/26/2019 10:40 PM - bmbouter
- Tags deleted (Pulp 3)

#16 - 01/13/2021 12:37 AM - dalley
- Platform Release set to 3.0.0
